import sys
#
if not Misc.CurrentScriptDirectory() in sys.path:
    sys.path.append(Misc.CurrentScriptDirectory())
#
import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
#
if not Misc.CheckSharedValue("BagOfHolding"):
    Misc.SendMessage("Bag ofHolding not defined")
    Stop()
#    
bagOfHolding = Items.FindBySerial(Misc.ReadSharedValue("BagOfHolding"))
Misc.SendMessage("BagOfHolding = 0x{:x}".format( bagOfHolding.Serial ))
backpack = Player.Backpack
#
scissors = Items.FindByID(0xf9f, -1, Player.Backpack.Serial)
if scissors != None:
    leather = common.findRecursive(Player.Backpack.Serial, [0x1079])
    for item in leather:
        Items.UseItem(scissors.Serial)
        Target.WaitForTarget(500, False)
        Target.TargetExecute(item.Serial)    
        Misc.Pause(500)
else:
    leather = common.findRecursive(Player.Backpack.Serial, [0x1079])
    for item in leather:
        Items.Move(item, bagOfHolding, 0)
#
# If reg keys, store those
reg_keys = common.findRecursiveWithColor(Player.Backpack.Serial, [ (0x176B, 0x0021) ]) 
if reg_keys is not None:
    Misc.WaitForContext(0x40451F01, 10000)
    Misc.ContextReply(0x40451F01, "Refill from stock")
    Gumps.WaitForGump(111922706, 2000)
    ButtonId = 0
    Switches = List[int]([])
    TextIds = List[int]([0])
    TextVal = List[str](['1'])
    Gumps.SendAdvancedAction(111922706, ButtonId, Switches, TextIds, TextVal)
    Gumps.SendAction(111922706, 0)
#
# move things to boh if possible
boh_types = [0x1bdd, 0x1bfb, 0x19b9, 0x1081, 0x26b4, 0xeed, 0x9f1, 0x318f, 0x3190, 0x3191, 0xf3f,  0xe21, 0x4BA4]    
boh_items = [i for i in common.findRecursive(Player.Backpack.Serial, boh_types) if i.Container != bagOfHolding.Serial]
for item in boh_items:
    Items.Move(item.Serial, bagOfHolding.Serial, 0)
    Misc.Pause(800)
#    
if Misc.CheckSharedValue("TokenBag"):
    #
    # Throw out the trash
    # move things to boh if possible
    trash_types = [0xf45, 0x13f6]    
    trash_items = [i for i in common.findRecursive(Player.Backpack.Serial, trash_types) if i.Container != bagOfHolding.Serial]
    for item in trash_items:
        Items.Move(item.Serial, Misc.ReadSharedValue("TokenBag"), 0)
        Misc.Pause(800)
#    
